<?php
/*
Title:		Email Imager v0.1
Author:		Corie Slate, House of Tech
License:		Free to use, free to change, and if changed must remain free

		www.houseoftech.com
*/

/* For use with encryption
if(file_exists("email_imager_func.php"))
{
	include("email_imager_func.php");
}

if(isset($_GET['enc'])) // encryption was used, decrypt it and set each $_GET[] variable
{
	$dec = decrypt($_GET['enc'],$_GET['k']);
	$var_array = explode("&", $dec);
	foreach($var_array as $var)
	{
		list($key, $value) = explode("=", $var);
		$_GET[$key] = $value;
	}
}
*/

$domain = "";

// Set image style based on $_GET variables
$font_file = $_GET['f'] . '.ttf';
if(!file_exists($font_file))
	$font_file = 'monofont.ttf'; // use arial if requested font isn't found

$string = $_GET['e'].$domain;
$font_size = $_GET['fs'];
$rotation = $_GET['r'];
$offset_x = 0;
$offset_y = 0;
//echo "$this->rot: ".$this->rot."<br>";
$bounds = ImageTTFBBox($font_size, $rotation, $font_file, "W");
		//if ($this->rot < 0) 
	//	{
	//		$font_height = abs($bounds[7]-$bounds[1]);		
	//	} 
	//	else if ($this->rot > 0) 
	//	{
	//	$font_height = abs($bounds[1]-$bounds[7]);
	//	} 
	//	else 
	//	{
			$font_height = abs($bounds[7]-$bounds[1]);
	//	}

// Figure out how large the bounding image box will be based on the font size and length of the text
$bbox = imageftbbox($font_size, $rotation, $font_file, $string);
if ($rotation < 0) 
		{
			$width = abs($bbox[4]-$bbox[0]);
			$height = abs($bbox[3]-$bbox[7]);
		} 
		else if ($rotation > 0) 
		{
			$width = abs($bbox[2]-$bbox[6])+10;
			$height = abs($bbox[1]-$bbox[5])+10;
			$offset_y = abs($bbox[7]-$bbox[5])+$font_height;
			$offset_x = abs($bbox[0]-$bbox[6]);
		} 
		else
		{
$width = abs($bbox[4] - $bbox[0]) +2;
$height = abs($bbox[1] - $bbox[5]) +6; // Add 6 to height if uppercase or tall characters are used to prevent top from being cut off
$offset_y = $font_height;;
			$offset_x = 0;		
}

$im = imagecreate($width,$height);

// Set color, background color, and line color
// Will accept html color codes (000000) and rgb codes (0,0,0)
if(strstr($_GET['bc'], ","))
{
	$bc_array = explode(",", $_GET['bc']);
	$background_color = imagecolorallocate($im, intval($bc_array[0]),intval($bc_array[1]),intval($bc_array[2]));
}
elseif(strlen($_GET['bc']) == 6 || (strlen($_GET['bc']) == 7))
{
	$_GET['bc'] = str_replace('^', '', $_GET['bc']);
	$bc_array[0] = hexdec('0x' . substr($_GET['bc'], 0, 2));
	$bc_array[1] = hexdec('0x' . substr($_GET['bc'], 2, 2));
	$bc_array[2] = hexdec('0x' . substr($_GET['bc'], 4, 2));
	$background_color = imagecolorallocate($im, $bc_array[0],$bc_array[1],$bc_array[2]);
}
else // set default background color to white
{
	$background_color = imagecolorallocate($im, 255,255,255);
}

if(strstr($_GET['c'], ","))
{
	$c_array = explode(",", $_GET['c']);
	$color = imagecolorallocate($im, intval($c_array[0]),intval($c_array[1]),intval($c_array[2]));
}
else if(strlen($_GET['c']) == 6 || (strlen($_GET['c']) == 7))
{	
	$_GET['c'] = str_replace('^', '', $_GET['c']);	
	$c_array[0] = hexdec('0x' . substr($_GET['c'], 0, 2));
	$c_array[1] = hexdec('0x' . substr($_GET['c'], 2, 2));
	$c_array[2] = hexdec('0x' . substr($_GET['c'], 4, 2));
	$color = imagecolorallocate($im, $c_array[0],$c_array[1],$c_array[2]);
}
/*else // set default text color to black
{
	$color = imagecolorallocate($im, 0,0,0);
}
*/
if(strstr($_GET['l'], ","))
{
	$l_array = explode(",", $_GET['l']);
	$line_color = imagecolorallocate($im, intval($l_array[0]),intval($l_array[1]),intval($l_array[2]));
	$draw_line = true;
}
elseif(strlen($_GET['l']) == 6)
{
	$l_array[0] = hexdec('0x' . substr($_GET['l'], 0, 2));
	$l_array[1] = hexdec('0x' . substr($_GET['l'], 2, 2));
	$l_array[2] = hexdec('0x' . substr($_GET['l'], 4, 2));
	$line_color = imagecolorallocate($im, $l_array[0],$l_array[1],$l_array[2]);
	$draw_line = true;
}
elseif($_GET['l'] == 'true') // set default line color to background_color
{
	$line_color = $background_color;
	$draw_line = true;
}

// Output the image
imagefttext($im, $font_size, $rotation, $offset_x, $offset_y+3, $color, $font_file, $string);

// Draw line across image if requested
if($draw_line)
{
	for($i=-20;$i<=$width;$i+=3)
	{
		//imageline($im, 0,$i,$width,$i,$line_color); // straight line
		imageline($im, $i,0,$i+20,$height,$line_color); // horizontal line
	}
}
header("Content-type: image/png");
imagepng($im);
imagedestroy($im);
?> 